<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="羊舍id" prop="sheepfoldId">
        <el-input
          v-model="queryParams.sheepfoldId"
          placeholder="请输入羊舍id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="消毒日期" prop="datetime">
        <el-date-picker clearable
          v-model="queryParams.datetime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择消毒日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="技术员" prop="technician">
        <el-input
          v-model="queryParams.technician"
          placeholder="请输入技术员"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="消毒方式" prop="way">
        <el-input
          v-model="queryParams.way"
          placeholder="请输入消毒方式"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="药品使用记录id" prop="usageId">
        <el-input
          v-model="queryParams.usageId"
          placeholder="请输入药品使用记录id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="比例" prop="ratio">
        <el-input
          v-model="queryParams.ratio"
          placeholder="请输入比例"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="备注" prop="comment">
        <el-input
          v-model="queryParams.comment"
          placeholder="请输入备注"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['biosafety:disinfect:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['biosafety:disinfect:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['biosafety:disinfect:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['biosafety:disinfect:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="disinfectList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="羊舍id" align="center" prop="sheepfoldId" />
      <el-table-column label="消毒日期" align="center" prop="datetime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.datetime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="技术员" align="center" prop="technician" />
      <el-table-column label="消毒方式" align="center" prop="way" />
      <el-table-column label="药品使用记录id" align="center" prop="usageId" />
      <el-table-column label="比例" align="center" prop="ratio" />
      <el-table-column label="备注" align="center" prop="comment" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['biosafety:disinfect:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['biosafety:disinfect:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改消毒记录对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="disinfectRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="羊舍id" prop="sheepfoldId">
          <el-input v-model="form.sheepfoldId" placeholder="请输入羊舍id" />
        </el-form-item>
        <el-form-item label="消毒日期" prop="datetime">
          <el-date-picker clearable
            v-model="form.datetime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择消毒日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="技术员" prop="technician">
          <el-input v-model="form.technician" placeholder="请输入技术员" />
        </el-form-item>
        <el-form-item label="消毒方式" prop="way">
          <el-input v-model="form.way" placeholder="请输入消毒方式" />
        </el-form-item>
        <el-form-item label="药品使用记录id" prop="usageId">
          <el-input v-model="form.usageId" placeholder="请输入药品使用记录id" />
        </el-form-item>
        <el-form-item label="比例" prop="ratio">
          <el-input v-model="form.ratio" placeholder="请输入比例" />
        </el-form-item>
        <el-form-item label="备注" prop="comment">
          <el-input v-model="form.comment" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Disinfect">
import { listDisinfect, getDisinfect, delDisinfect, addDisinfect, updateDisinfect } from "@/api/biosafety/disinfect"

const { proxy } = getCurrentInstance()

const disinfectList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    sheepfoldId: null,
    datetime: null,
    technician: null,
    way: null,
    usageId: null,
    ratio: null,
    comment: null,
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询消毒记录列表 */
function getList() {
  loading.value = true
  listDisinfect(queryParams.value).then(response => {
    disinfectList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    sheepfoldId: null,
    datetime: null,
    technician: null,
    way: null,
    usageId: null,
    ratio: null,
    comment: null,
    updateBy: null,
    updateTime: null,
    createBy: null,
    createTime: null
  }
  proxy.resetForm("disinfectRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加消毒记录"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getDisinfect(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改消毒记录"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["disinfectRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateDisinfect(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addDisinfect(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除消毒记录编号为"' + _ids + '"的数据项？').then(function() {
    return delDisinfect(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('biosafety/disinfect/export', {
    ...queryParams.value
  }, `disinfect_${new Date().getTime()}.xlsx`)
}

getList()
</script>
